// $ANTLR 3.1.3 Mar 17, 2009 19:23:44 com/rempl/core/model/Transform.g 2011-03-19 12:33:00

    package com.rempl.core.model;
    import com.rempl.api.Element;
    import java.util.ArrayList;
    import java.util.Collection;
    import java.util.Map;
    import java.util.HashMap;


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

/**
 * @version $Id: Transform.g 692 2011-03-16 18:07:50Z yegor256@yahoo.com $
 */
public class TransformParser extends Parser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "NAME", "QUOTE", "TEXT", "SPACE", "':'", "'{'", "';'", "'}'"
    };
    public static final int QUOTE=5;
    public static final int NAME=4;
    public static final int T__11=11;
    public static final int T__10=10;
    public static final int TEXT=6;
    public static final int SPACE=7;
    public static final int EOF=-1;
    public static final int T__9=9;
    public static final int T__8=8;

    // delegates
    // delegators


        public TransformParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public TransformParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return TransformParser.tokenNames; }
    public String getGrammarFileName() { return "com/rempl/core/model/Transform.g"; }



    // $ANTLR start "elements"
    // com/rempl/core/model/Transform.g:24:1: elements returns [Collection<Element> elements] : ( element )* EOF ;
    public final Collection<Element> elements() throws RecognitionException {
        Collection<Element> elements = null;

        Element element1 = null;


         elements = new ArrayList<Element>(); 
        try {
            // com/rempl/core/model/Transform.g:26:5: ( ( element )* EOF )
            // com/rempl/core/model/Transform.g:27:5: ( element )* EOF
            {
            // com/rempl/core/model/Transform.g:27:5: ( element )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( (LA1_0==NAME||LA1_0==8) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // com/rempl/core/model/Transform.g:28:9: element
            	    {
            	    pushFollow(FOLLOW_element_in_elements68);
            	    element1=element();

            	    state._fsp--;

            	     elements.add(element1); 

            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);

            match(input,EOF,FOLLOW_EOF_in_elements91); 

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return elements;
    }
    // $ANTLR end "elements"


    // $ANTLR start "element"
    // com/rempl/core/model/Transform.g:35:1: element returns [Element element] : (id= NAME )? ':' type= NAME '{' (slot= NAME ':' QUOTE TEXT QUOTE ';' )* '}' ';' ;
    public final Element element() throws RecognitionException {
        Element element = null;

        Token id=null;
        Token type=null;
        Token slot=null;
        Token TEXT2=null;

         Map<String, String> map = new HashMap<String, String>(); 
        try {
            // com/rempl/core/model/Transform.g:37:5: ( (id= NAME )? ':' type= NAME '{' (slot= NAME ':' QUOTE TEXT QUOTE ';' )* '}' ';' )
            // com/rempl/core/model/Transform.g:38:5: (id= NAME )? ':' type= NAME '{' (slot= NAME ':' QUOTE TEXT QUOTE ';' )* '}' ';'
            {
            // com/rempl/core/model/Transform.g:38:5: (id= NAME )?
            int alt2=2;
            int LA2_0 = input.LA(1);

            if ( (LA2_0==NAME) ) {
                alt2=1;
            }
            switch (alt2) {
                case 1 :
                    // com/rempl/core/model/Transform.g:38:7: id= NAME
                    {
                    id=(Token)match(input,NAME,FOLLOW_NAME_in_element130); 

                    }
                    break;

            }

            match(input,8,FOLLOW_8_in_element139); 
            type=(Token)match(input,NAME,FOLLOW_NAME_in_element147); 
            match(input,9,FOLLOW_9_in_element153); 
            // com/rempl/core/model/Transform.g:42:5: (slot= NAME ':' QUOTE TEXT QUOTE ';' )*
            loop3:
            do {
                int alt3=2;
                int LA3_0 = input.LA(1);

                if ( (LA3_0==NAME) ) {
                    alt3=1;
                }


                switch (alt3) {
            	case 1 :
            	    // com/rempl/core/model/Transform.g:43:9: slot= NAME ':' QUOTE TEXT QUOTE ';'
            	    {
            	    slot=(Token)match(input,NAME,FOLLOW_NAME_in_element171); 
            	    match(input,8,FOLLOW_8_in_element181); 
            	    match(input,QUOTE,FOLLOW_QUOTE_in_element191); 
            	    TEXT2=(Token)match(input,TEXT,FOLLOW_TEXT_in_element201); 
            	    match(input,QUOTE,FOLLOW_QUOTE_in_element211); 
            	    match(input,10,FOLLOW_10_in_element221); 
            	     map.put((slot!=null?slot.getText():null), (TEXT2!=null?TEXT2.getText():null)); 

            	    }
            	    break;

            	default :
            	    break loop3;
                }
            } while (true);

            match(input,11,FOLLOW_11_in_element244); 
            match(input,10,FOLLOW_10_in_element250); 

                    element = new Element((id!=null?id.getText():null), (type!=null?type.getText():null));
                    for (Map.Entry<String, String> entry : map.entrySet()) {
                        element.put(entry.getKey(), entry.getValue());
                    }
                

            }

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
        }
        finally {
        }
        return element;
    }
    // $ANTLR end "element"

    // Delegated rules


 

    public static final BitSet FOLLOW_element_in_elements68 = new BitSet(new long[]{0x0000000000000110L});
    public static final BitSet FOLLOW_EOF_in_elements91 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_NAME_in_element130 = new BitSet(new long[]{0x0000000000000100L});
    public static final BitSet FOLLOW_8_in_element139 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_NAME_in_element147 = new BitSet(new long[]{0x0000000000000200L});
    public static final BitSet FOLLOW_9_in_element153 = new BitSet(new long[]{0x0000000000000810L});
    public static final BitSet FOLLOW_NAME_in_element171 = new BitSet(new long[]{0x0000000000000100L});
    public static final BitSet FOLLOW_8_in_element181 = new BitSet(new long[]{0x0000000000000020L});
    public static final BitSet FOLLOW_QUOTE_in_element191 = new BitSet(new long[]{0x0000000000000040L});
    public static final BitSet FOLLOW_TEXT_in_element201 = new BitSet(new long[]{0x0000000000000020L});
    public static final BitSet FOLLOW_QUOTE_in_element211 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_10_in_element221 = new BitSet(new long[]{0x0000000000000810L});
    public static final BitSet FOLLOW_11_in_element244 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_10_in_element250 = new BitSet(new long[]{0x0000000000000002L});

}